package com.example.labstatus.ui.home;

import android.content.Intent;
import android.content.res.ColorStateList;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.widget.Toast;

import com.example.labstatus.DetailActivity;
import com.example.labstatus.HttpHandler;

import com.example.labstatus.MainActivity;
import com.example.labstatus.R;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;


import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

public class HomeFragment extends Fragment implements RecyclerViewAdapterSL2.ItemListener {

    private HomeViewModel homeViewModel;
    RecyclerView recyclerView;
    ArrayList arrayList;
    ProgressBar bar;
    View root;

    public String TAG = HomeFragment.class.getSimpleName();
    HashMap<String, Boolean> status=new HashMap<>();
    String SL2_ini="10.130.154.";
    boolean isFABOpen=false;
    FloatingActionButton fab_lab,fab_keyboard,fab_mouse,fab;
    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        homeViewModel =  ViewModelProviders.of(this).get(HomeViewModel.class);
        root = inflater.inflate(R.layout.fragment_home, container, false);
        bar=root.findViewById(R.id.pBar_SL2);
        bar.setVisibility(root.GONE);

        recyclerView = root.findViewById(R.id.recyclerViewSL2);
         fab =  root.findViewById(R.id.fab);
        fab_lab =  root.findViewById(R.id.fab_lab);
         fab_keyboard =  root.findViewById(R.id.fab_keyboard);
         fab_mouse =  root.findViewById(R.id.fab_mouse);

        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(!isFABOpen){
                    showFABMenu();
                }else{
                    closeFABMenu();
                }
            }
        });
        fab_lab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));

            }
        });
        fab_keyboard.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));

            }
        });
        fab_mouse.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                         }
        });


        arrayList = new ArrayList();
        new GetLabStatus().execute();



        return root;
    }
    private void showFABMenu(){
        isFABOpen=true;
        fab.setImageResource(R.drawable.ic_fab_right);
        fab_lab.animate().translationX(-getResources().getDimension(R.dimen.standard_65));

        fab_keyboard.animate().translationX(-getResources().getDimension(R.dimen.standard_115));
        fab_mouse.animate().translationX(-getResources().getDimension(R.dimen.standard_165));
    }

    private void closeFABMenu(){
        isFABOpen=false;
        fab.setImageResource(R.drawable.ic_fab_left);
        fab_lab.animate().translationX(0);

        fab_keyboard.animate().translationX(0);
        fab_mouse.animate().translationX(0);
    }

    @Override
    public void onItemClick(HomeViewModel item) {
        //Toast.makeText(getContext(), item.text + " is clicked", Toast.LENGTH_SHORT).show();
        Intent intent=new Intent(getActivity(), DetailActivity.class);
        intent.putExtra("lab","sl2");
        intent.putExtra("pc",item.text);

        if(status.get(SL2_ini+item.text)==false)
            Snackbar.make(root, "System offline", Snackbar.LENGTH_LONG)
                    .setAction("Action", null).show();
        else{
            startActivity(intent);
        }


    }

    private class GetLabStatus extends AsyncTask<Void, Void, Void> {


        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    bar.setVisibility(root.VISIBLE);
                }
            });

        }

        @Override
        protected Void doInBackground(Void... arg0) {
            HttpHandler sh = new HttpHandler();
            // Making a request to url and getting response
            String url = "http://10.130.150.223:5000/lab/sl2/status";
            String jsonStr = sh.makeServiceCall(url);

            //Log.e(TAG, "Response from url: " + jsonStr);
            if (jsonStr != null) {
                try {
                    JSONObject jsonObj = new JSONObject(jsonStr);

                    Iterator<String> iter = jsonObj.keys();
                    while (iter.hasNext()) {
                        String key = iter.next();
                        try {
                             Boolean value = (Boolean) jsonObj.get(key);
                            status.put(key,value);
                        } catch (JSONException e) {
                            // Something went wrong!
                        }
                    }


                } catch (final JSONException e) {
                    Log.e(TAG, "Json parsing error: " + e.getMessage());
              /*  runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(getApplicatioContext(),
                                "Json parsing error: " + e.getMessage(),
                                Toast.LENGTH_LONG).show();
                    }
                });
*/
                }

            } else {
                Log.e(TAG, "Couldn't get json from server.");
              /*  runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(getApplicationContext(),
                                "Couldn't get json from server. Check LogCat for possible errors!",
                                Toast.LENGTH_LONG).show();
                    }
                });*/
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            /*ListAdapter adapter = new SimpleAdapter(MainActivity.this, contactList,
                    R.layout.list_item, new String[]{ "email","mobile"},
                    new int[]{R.id.email, R.id.mobile});
            lv.setAdapter(adapter);*/
            try {
                String label;
                Integer no;
                for (int i = -1; i < 10; i++) {
                    for (int j = 1; j <= 15; j++) {

                        if (i == -1) {
                            if (j == 8) {
                                no = 200;
                                label = no.toString();
                            } else {
                                label = "";
                            }
                        } else {
                            if (j == 8) {
                                label = "";
                            } else {
                                if (j > 8) {
                                    no = (14 * i) + j - 1;
                                    if (no > 132) {
                                        label = "";
                                    } else {
                                        label = no.toString();
                                    }
                                } else {
                                    no = (14 * i) + j;
                                    if (no > 132) {
                                        label = "";
                                    } else {
                                        label = no.toString();
                                    }
                                }
                            }
                        }
                        if (label != "") {
                            String ip = SL2_ini + label;
                            boolean temp = false;
                            if (status.get(ip) != null) {
                                temp = status.get(ip);
                            }

                            if (temp == true) {
                                arrayList.add(new HomeViewModel(label, "#008577"));
                            } else {
                                arrayList.add(new HomeViewModel(label, "#D81B60"));
                            }
                        } else {
                            arrayList.add(new HomeViewModel(label, "#D81B60"));
                        }
                    }
                }
/*
        arrayList.add(new HomeViewModel("2", "#FF0000"));
        arrayList.add(new HomeViewModel("3", "#FF0000"));
        arrayList.add(new HomeViewModel("4", "#FF0000"));
        arrayList.add(new HomeViewModel("5", "#FF0000"));
        arrayList.add(new HomeViewModel("6", "#FF0000"));
        arrayList.add(new HomeViewModel("7", "#FF0000"));*/

                RecyclerViewAdapterSL2 adapter = new RecyclerViewAdapterSL2(getContext(), arrayList, HomeFragment.this);
                recyclerView.setAdapter(adapter);
                GridLayoutManager manager = new GridLayoutManager(getContext(), 15, GridLayoutManager.VERTICAL, false);
                recyclerView.setLayoutManager(manager);
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        bar.setVisibility(root.GONE);
                    }
                });
            }
            catch(Exception e){
                Log.e(TAG,e.getMessage());
            }
        }
    }

}