package com.example.labstatus.ui.notifications;

import android.content.Intent;
import android.content.res.ColorStateList;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.labstatus.DetailActivity;
import com.example.labstatus.HttpHandler;
import com.example.labstatus.R;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;


import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

public class NotificationsFragment extends Fragment implements RecyclerViewAdapterBasement.ItemListener {

    private NotificationsViewModel notificationsViewModel;
    RecyclerView recyclerView;
    ArrayList arrayList;
    ProgressBar bar;
    View root;
    public String TAG = NotificationsFragment.class.getSimpleName();
    HashMap<String, Boolean> status=new HashMap<>();
    String CS101_ini="10.130.152.";
    boolean isFABOpen=false;
    FloatingActionButton fab_lab,fab_keyboard,fab_mouse,fab;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        notificationsViewModel =
                ViewModelProviders.of(this).get(NotificationsViewModel.class);
        View root = inflater.inflate(R.layout.fragment_notifications, container, false);
        bar=root.findViewById(R.id.pBar_CS101);
        bar.setVisibility(root.GONE);
        /*final TextView textView = root.findViewById(R.id.text_notifications);
        notificationsViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });*/
        recyclerView = root.findViewById(R.id.recyclerViewBasement);
        arrayList = new ArrayList();
        fab =  root.findViewById(R.id.fab_cs101);
        fab_lab =  root.findViewById(R.id.fab_lab_cs101);
        fab_keyboard =  root.findViewById(R.id.fab_keyboard_cs101);
        fab_mouse =  root.findViewById(R.id.fab_mouse_cs101);

        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(!isFABOpen){
                    showFABMenu();
                }else{
                    closeFABMenu();
                }
            }
        });
        fab_lab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
           //     fab_search.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
            }
        });
        fab_keyboard.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
              //  fab_search.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
            }
        });
        fab_mouse.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
                fab_lab.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
              //  fab_search.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorAccent)));
            }
        });


        new GetLabStatus().execute();

        return root;
    }
    private void showFABMenu(){
        isFABOpen=true;
        fab.setImageResource(R.drawable.ic_fab_right);
        fab_lab.animate().translationX(-getResources().getDimension(R.dimen.standard_65));


        fab_keyboard.animate().translationX(-getResources().getDimension(R.dimen.standard_115));
        fab_mouse.animate().translationX(-getResources().getDimension(R.dimen.standard_165));
    }

    private void closeFABMenu(){
        isFABOpen=false;
        fab.setImageResource(R.drawable.ic_fab_left);
        fab_lab.animate().translationX(0);

        fab_keyboard.animate().translationX(0);
        fab_mouse.animate().translationX(0);
    }

    @Override
    public void onItemClick(NotificationsViewModel item) {
        //Toast.makeText(getContext(), item.text + " is clicked", Toast.LENGTH_SHORT).show();
        Intent intent=new Intent(getActivity(), DetailActivity.class);
        intent.putExtra("lab","cs101");
        intent.putExtra("pc",item.text);

        if(status.get(CS101_ini+item.text)==false)
            Snackbar.make(root, "System offline", Snackbar.LENGTH_LONG)
                    .setAction("Action", null).show();
        else{
            startActivity(intent);
        }
    }

    private class GetLabStatus extends AsyncTask<Void, Void, Void> {


        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    bar.setVisibility(root.VISIBLE);
                }
            });

        }

        @Override
        protected Void doInBackground(Void... arg0) {
            HttpHandler sh = new HttpHandler();
            // Making a request to url and getting response
            String url = "http://10.130.150.223:5000/lab/cs101/status";
            String jsonStr = sh.makeServiceCall(url);

            //Log.e(TAG, "Response from url: " + jsonStr);
            if (jsonStr != null) {
                try {
                    JSONObject jsonObj = new JSONObject(jsonStr);

                    Iterator<String> iter = jsonObj.keys();
                    while (iter.hasNext()) {
                        String key = iter.next();
                        try {
                            Boolean value = (Boolean) jsonObj.get(key);
                            status.put(key,value);
                        } catch (JSONException e) {
                            // Something went wrong!
                        }
                    }


                } catch (final JSONException e) {
                    Log.e(TAG, "Json parsing error: " + e.getMessage());
              /*  runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(getApplicatioContext(),
                                "Json parsing error: " + e.getMessage(),
                                Toast.LENGTH_LONG).show();
                    }
                });
*/
                }

            } else {
                Log.e(TAG, "Couldn't get json from server.");
              /*  runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(getApplicationContext(),
                                "Couldn't get json from server. Check LogCat for possible errors!",
                                Toast.LENGTH_LONG).show();
                    }
                });*/
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            String label;
            Integer no = 0;
            int counter = 1;
            try{
            for (int i = -1; i < 13; i++) {
                for (int j = 1; j <= 15; j++) {

                    if (i == -1) {
                        if (j == 8) {
                            no = 200;
                            label = no.toString();
                        } else {
                            label = "";
                        }
                    } else if (i == 0 && (j == 1 || j == 2 || j == 14 || j == 15)) {
                        label = "";
                    } else if (i == 1 && (j == 1 || j == 15)) {
                        label = "";
                    } else if (i == 2 && (j == 1 || j == 15)) {
                        label = "";
                    } else {
                        if (j == 5 || j == 11) {
                            label = "";
                        } else {


                            no = counter;
                            counter++;
                            if (no > 148) {
                                label = "";
                            } else {
                                label = no.toString();
                            }
                           /* no = (14 * i) + j;
                            if(no>132){
                                label="";
                            }*/


                        }
                    }

                    if (label != "") {
                        String ip = CS101_ini + label;
                        boolean temp = false;
                        if (status.get(ip) != null) {
                            temp = status.get(ip);
                        }

                        if (temp == true) {
                            arrayList.add(new NotificationsViewModel(label, "#008577"));
                        } else {
                            arrayList.add(new NotificationsViewModel(label, "#D81B60"));
                        }
                    } else {
                        arrayList.add(new NotificationsViewModel(label, "#D81B60"));
                    }
                }
            }

            RecyclerViewAdapterBasement adapter = new RecyclerViewAdapterBasement(getContext(), arrayList, NotificationsFragment.this);
            recyclerView.setAdapter(adapter);


            /**
             AutoFitGridLayoutManager that auto fits the cells by the column width defined.
             **/

        /*AutoFitGridLayoutManager layoutManager = new AutoFitGridLayoutManager(this, 500);
        recyclerView.setLayoutManager(layoutManager);*/


            /**
             Simple GridLayoutManager that spans two columns
             **/
            GridLayoutManager manager = new GridLayoutManager(getContext(), 15, GridLayoutManager.VERTICAL, false);
            recyclerView.setLayoutManager(manager);
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    bar.setVisibility(root.GONE);
                }
            });
        }
                        catch(Exception e){
                Log.e(TAG,e.getMessage());
            }
        }
    }
}